/* Tabela MUNICIPIO: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MUNICIPIO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela MUNICIPIO utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_MUNICIPIO
AFTER DELETE OR INSERT OR UPDATE
ON MUNICIPIO FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';
   IF DELETING THEN

      IF :OLD.CDPAIS IS NOT NULL THEN
         V_DESC := V_DESC || 'Pais=' || :OLD.CDPAIS;
      END IF;

      IF :OLD.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' SiglaEst=' || :OLD.SGESTADO;
      END IF;

      IF :OLD.CDMUNICIBGE IS NOT NULL THEN
         V_DESC := V_DESC || ' CodIBGE=' || :OLD.CDMUNICIBGE;
      END IF;

      IF :OLD.CDMUNIEXPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CodExport=' || :OLD.CDMUNIEXPO;
      END IF;

      IF :OLD.IDMUNIALC IS NOT NULL THEN
         V_DESC := V_DESC || ' AreaLivreCom=' || :OLD.IDMUNIALC;
      END IF;

      IF :OLD.NMMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' NomeMunic=' || :OLD.NMMUNICIPIO;
      END IF;

      IF :OLD.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' CodMunic=' || :OLD.CDMUNICIPIO;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDPAIS||:OLD.SGESTADO||:OLD.CDMUNICIPIO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPAIS      <> :NEW.CDPAIS)      OR
            (:OLD.SGESTADO    <> :NEW.SGESTADO)    OR
            (:OLD.CDMUNICIBGE <> :NEW.CDMUNICIBGE) OR
            (:OLD.CDMUNIEXPO  <> :NEW.CDMUNIEXPO)  OR
            (:OLD.IDMUNIALC   <> :NEW.IDMUNIALC)   OR
            (:OLD.NMMUNICIPIO <> :NEW.NMMUNICIPIO) OR
            (:OLD.CDMUNICIPIO <> :NEW.CDMUNICIPIO) THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDPAIS||:OLD.SGESTADO||:OLD.CDMUNICIPIO;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDPAIS||:NEW.SGESTADO||:NEW.CDMUNICIPIO;
      END IF;

      IF :NEW.CDPAIS IS NOT NULL THEN
         V_DESC := V_DESC || 'Pais=' || :NEW.CDPAIS;
      END IF;

      IF :NEW.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' SiglaEst=' || :NEW.SGESTADO;
      END IF;

      IF :NEW.CDMUNICIBGE IS NOT NULL THEN
         V_DESC := V_DESC || ' CodIBGE=' || :NEW.CDMUNICIBGE;
      END IF;

      IF :NEW.CDMUNIEXPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CodExport=' || :NEW.CDMUNIEXPO;
      END IF;

      IF :NEW.IDMUNIALC IS NOT NULL THEN
         V_DESC := V_DESC || ' AreaLivreCom=' || :NEW.IDMUNIALC;
      END IF;

      IF :NEW.NMMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' NomeMunic=' || :NEW.NMMUNICIPIO;
      END IF;

      IF :NEW.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' CodMunic=' || :NEW.CDMUNICIPIO;
      END IF;

   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('MUNICIPIO',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_MUNICIPIO','4.09.060'); END;
/
