/*---------------------------------------------------------+
+ PROCEDURE  CRIA_DIME                                     +
+ FUNO: CRIAO DE DIMENSES DE DW NA BASE DE DADOS      +
+                                                          +
+ CRIAO: 27/09/2007                                      +
+ RAPHAEL ERNANI RODRIGUES                                 +
+                                                          +
+---------------------------------------------------------*/
create or replace
PROCEDURE CRIA_DIME (P_CDTABELADW IN VARCHAR2,
                     P_CDITEMDIME IN VARCHAR2,
                     P_NMITEMDIME IN VARCHAR2,
                     P_CDTABELADIME IN VARCHAR2,
                     P_DSPKDIME IN VARCHAR2,
                     P_DSITEMDIME IN VARCHAR2,
                     P_DSPKDIME2 IN VARCHAR2)
IS
   V_COUNT       INTEGER;
   V_COUNT2      INTEGER;
   V_ERRO        INTEGER := 0;
   V_NRSEQUEDIME VARCHAR2(05);
   V_NMITEMDIME  VARCHAR2(30);
   V_TRY         INTEGER := 0;
BEGIN
   /*   INSERE DIMENSES   */
   SELECT COUNT(*)
   INTO   V_COUNT
   FROM   DIMENSAODW
   WHERE  CDTABELADW = P_CDTABELADW
     AND  CDITEMDIME = P_CDITEMDIME;
   IF V_COUNT=0 THEN
      IF P_CDTABELADIME IS NOT NULL THEN
         BEGIN
            IF P_DSPKDIME2 IS NULL THEN
               SELECT NRSEQUEDIME
               INTO   V_NRSEQUEDIME
               FROM   DIMENSAODIME
               WHERE  CDTABELADIME = P_CDTABELADIME
                 AND  DSPKDIME     = P_DSPKDIME
                 AND  DSITEMDIME   = P_DSITEMDIME
                 AND  ROWNUM = 1; -- O PRIMEIRO REGISTRO QUE SATISFIZER A CONDIO
           ELSE
               SELECT NRSEQUEDIME
               INTO   V_NRSEQUEDIME
               FROM   DIMENSAODIME
               WHERE  CDTABELADIME = P_CDTABELADIME
                 AND  DSPKDIME     = P_DSPKDIME
                 AND  DSITEMDIME   = P_DSITEMDIME
                 AND  DSPKDIME2    = P_DSPKDIME2;
           END IF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               SELECT LPAD(NVL(MAX(NRSEQUEDIME)+1,0),5,'0')
               INTO V_NRSEQUEDIME
               FROM DIMENSAODIME;
               
               V_NMITEMDIME := P_NMITEMDIME;
               
               LOOP 
                  SELECT COUNT(*)
                  INTO   V_COUNT
                  FROM   DIMENSAODIME
                  WHERE  NMITEMDIME = V_NMITEMDIME;
                  IF V_COUNT<>0 THEN
                     IF LENGTH(V_NMITEMDIME||V_TRY)<=30 THEN
                        V_NMITEMDIME := V_NMITEMDIME||V_TRY;
                     ELSE
                        V_TRY := V_TRY + 1;
                        V_NMITEMDIME := P_NMITEMDIME;
                        IF LENGTH(V_NMITEMDIME||V_TRY)>=30 THEN
                           V_ERRO := 1;
                        END IF;
                     END IF;
                  ELSE
                     INSERT INTO DIMENSAODIME
                     (NRSEQUEDIME,  NMITEMDIME,  CDTABELADIME,  DSPKDIME,  DSITEMDIME,  DSPKDIME2,  IDDIMENSAODW)
                     VALUES
                     (V_NRSEQUEDIME,V_NMITEMDIME,P_CDTABELADIME,P_DSPKDIME,P_DSITEMDIME,P_DSPKDIME2,'S'); 
                  END IF;   
                  EXIT WHEN (V_COUNT = 0) OR (V_ERRO = 1); 
               END LOOP;
         END;
      ELSE   
         BEGIN
            SELECT NRSEQUEDIME
            INTO   V_NRSEQUEDIME
            FROM   DIMENSAODIME
            WHERE  NMITEMDIME = P_NMITEMDIME
              AND  ROWNUM = 1; -- O PRIMEIRO REGISTRO QUE SATISFIZER A CONDIO
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               SELECT LPAD(NVL(MAX(NRSEQUEDIME)+1,0),5,'0')
               INTO V_NRSEQUEDIME
               FROM DIMENSAODIME;
               
               V_NMITEMDIME := P_NMITEMDIME;
               
               LOOP 
                  SELECT COUNT(*)
                  INTO   V_COUNT
                  FROM   DIMENSAODIME
                  WHERE  NMITEMDIME = V_NMITEMDIME;
                  IF V_COUNT<>0 THEN
                     IF LENGTH(V_NMITEMDIME||V_TRY)<=30 THEN
                        V_NMITEMDIME := V_NMITEMDIME||V_TRY;
                     ELSE
                        V_TRY := V_TRY + 1;
                        V_NMITEMDIME := P_NMITEMDIME;
                        IF LENGTH(V_NMITEMDIME||V_TRY)>=30 THEN
                           V_ERRO := 1;
                        END IF;
                     END IF;
                  ELSE
                     INSERT INTO DIMENSAODIME
                     (NRSEQUEDIME,  NMITEMDIME,  CDTABELADIME,  DSPKDIME,  DSITEMDIME,  DSPKDIME2,  IDDIMENSAODW)
                     VALUES
                     (V_NRSEQUEDIME,V_NMITEMDIME,P_CDTABELADIME,P_DSPKDIME,P_DSITEMDIME,P_DSPKDIME2,'S'); 
                  END IF;   
                  EXIT WHEN (V_COUNT = 0) OR (V_ERRO = 1); 
               END LOOP;
         END;        
      END IF;
      IF V_ERRO=0 THEN
         SELECT COUNT(*)
         INTO V_COUNT
         FROM TABELADW
         WHERE CDTABELADW = P_CDTABELADW;
         IF V_COUNT=0 THEN
            INSERT INTO TABELADW 
            (CDTABELADW, NMTABELADW) 
            VALUES
            (P_CDTABELADW, P_CDTABELADW);
         END IF;
         
         INSERT INTO DIMENSAODW
         (CDTABELADW,CDITEMDIME,NRSEQUEDIME)
         VALUES
         (P_CDTABELADW,P_CDITEMDIME,V_NRSEQUEDIME);
      END IF;    
      COMMIT;
   END IF; 
END;
/


--VERSAO--
BEGIN ATUVEROBJ('CRIA_DIME','4.11.000'); END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CRIA_DIME','5.01.004'); END;
/

