/* Trigger para gravar processos realizados encima da tabela "CODSITUTRIBNFE"*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_DFS_CODSITUTRIBNFE' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)
DROP TRIGGER LOG_DFS_CODSITUTRIBNFE
GO
CREATE TRIGGER LOG_DFS_CODSITUTRIBNFE
ON CODSITUTRIBNFE
FOR UPDATE,INSERT, DELETE
AS BEGIN

DECLARE @V_DSREMOTEADDR        VARCHAR(15);
DECLARE @V_DSREMOTEHOST        VARCHAR(15);
DECLARE @V_DSSERVERRDM         VARCHAR(20);
DECLARE @V_DSSERVMETHOD        VARCHAR(30);
DECLARE @V_DSREMOTEOPER        VARCHAR(12);
DECLARE @V_DESC                VARCHAR(300);
DECLARE @V_ITPESQ              VARCHAR(20);
DECLARE @V_NMOPERADOR          VARCHAR(40);
DECLARE @V_IDTIPOOPER          VARCHAR(1);
DECLARE @V_IDCOMANDO           VARCHAR(1);

DECLARE @V_NEW_NRINCIDCST      VARCHAR(10);
DECLARE @V_NEW_CDIMPOSTO       VARCHAR(2);
DECLARE @V_NEW_CDSITUTRIBNFE   VARCHAR(2);
DECLARE @V_NEW_IDMODBCNFE      VARCHAR(1);
DECLARE @V_NEW_IDMODBCSTNFE    VARCHAR(1);
DECLARE @V_NEW_CDTPCRPICOSTNFE VARCHAR(3);
DECLARE @V_NEW_CDNATUBCPCSTNFE VARCHAR(2);
DECLARE @V_NEW_IDENTSAICSTNFE  VARCHAR(1);
DECLARE @V_NEW_CDPRODUTO       VARCHAR(10);
DECLARE @V_NEW_IDENTRSAIDOP    VARCHAR(1);
DECLARE @V_NEW_CDTIPOOPER      VARCHAR(2);
DECLARE @V_NEW_CDEMPRESA       VARCHAR(2);
DECLARE @V_NEW_CDGRUPOFISC     VARCHAR(3);

DECLARE @V_OLD_NRINCIDCST      VARCHAR(10);
DECLARE @V_OLD_CDIMPOSTO       VARCHAR(2);
DECLARE @V_OLD_CDSITUTRIBNFE   VARCHAR(2);
DECLARE @V_OLD_IDMODBCNFE      VARCHAR(1);
DECLARE @V_OLD_IDMODBCSTNFE    VARCHAR(1);
DECLARE @V_OLD_CDTPCRPICOSTNFE VARCHAR(3);
DECLARE @V_OLD_CDNATUBCPCSTNFE VARCHAR(2);
DECLARE @V_OLD_IDENTSAICSTNFE  VARCHAR(1);
DECLARE @V_OLD_CDPRODUTO       VARCHAR(10);
DECLARE @V_OLD_IDENTRSAIDOP    VARCHAR(1);
DECLARE @V_OLD_CDTIPOOPER      VARCHAR(2);
DECLARE @V_OLD_CDEMPRESA       VARCHAR(2);
DECLARE @V_OLD_CDGRUPOFISC     VARCHAR(3);


   SET  @V_DESC       = '';
   SET  @V_ITPESQ     = '';
   SET  @V_NMOPERADOR = '';
   SET  @V_IDTIPOOPER = '';
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,  @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'I' IDCOMANDO,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NRINCIDCST,
                 CDIMPOSTO,
                 CDSITUTRIBNFE,
                 IDMODBCNFE,
                 IDMODBCSTNFE,
                 CDTPCRPICOSTNFE,
                 CDNATUBCPCSTNFE,
                 IDENTSAICSTNFE,
                 CDPRODUTO,
                 IDENTRSAIDOP,
                 CDTIPOOPER,
                 CDEMPRESA,
                 CDGRUPOFISC
      FROM INSERTED
      WHERE 0 = (SELECT COUNT(*) FROM DELETED)

      UNION ALL

      SELECT 'D' IDCOMANDO,
                 NRINCIDCST,
                 CDIMPOSTO,
                 CDSITUTRIBNFE,
                 IDMODBCNFE,
                 IDMODBCSTNFE,
                 CDTPCRPICOSTNFE,
                 CDNATUBCPCSTNFE,
                 IDENTSAICSTNFE,
                 CDPRODUTO,
                 IDENTRSAIDOP,
                 CDTIPOOPER,
                 CDEMPRESA,
                 CDGRUPOFISC,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL
      FROM DELETED
      WHERE 0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT 'U' IDCOMANDO,
                 DELETED.NRINCIDCST,
                 DELETED.CDIMPOSTO,
                 DELETED.CDSITUTRIBNFE,
                 DELETED.IDMODBCNFE,
                 DELETED.IDMODBCSTNFE,
                 DELETED.CDTPCRPICOSTNFE,
                 DELETED.CDNATUBCPCSTNFE,
                 DELETED.IDENTSAICSTNFE,
                 DELETED.CDPRODUTO,
                 DELETED.IDENTRSAIDOP,
                 DELETED.CDTIPOOPER,
                 DELETED.CDEMPRESA,
                 DELETED.CDGRUPOFISC,
                 INSERTED.NRINCIDCST,
                 INSERTED.CDIMPOSTO,
                 INSERTED.CDSITUTRIBNFE,
                 INSERTED.IDMODBCNFE,
                 INSERTED.IDMODBCSTNFE,
                 INSERTED.CDTPCRPICOSTNFE,
                 INSERTED.CDNATUBCPCSTNFE,
                 INSERTED.IDENTSAICSTNFE,
                 INSERTED.CDPRODUTO,
                 INSERTED.IDENTRSAIDOP,
                 INSERTED.CDTIPOOPER,
                 INSERTED.CDEMPRESA,
                 INSERTED.CDGRUPOFISC
      FROM DELETED, INSERTED
      WHERE INSERTED.NRINCIDCST = DELETED.NRINCIDCST

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                 @V_OLD_NRINCIDCST      , @V_OLD_CDIMPOSTO,
                                 @V_OLD_CDSITUTRIBNFE   , @V_OLD_IDMODBCNFE,
                                 @V_OLD_IDMODBCSTNFE    , @V_OLD_CDTPCRPICOSTNFE,
                                 @V_OLD_CDNATUBCPCSTNFE , @V_OLD_IDENTSAICSTNFE,
                                 @V_OLD_CDPRODUTO       , @V_OLD_IDENTRSAIDOP ,
                                 @V_OLD_CDTIPOOPER      , @V_OLD_CDEMPRESA,  @V_OLD_CDGRUPOFISC,

                                 @V_NEW_NRINCIDCST      , @V_NEW_CDIMPOSTO,
                                 @V_NEW_CDSITUTRIBNFE   , @V_NEW_IDMODBCNFE,
                                 @V_NEW_IDMODBCSTNFE    , @V_NEW_CDTPCRPICOSTNFE,
                                 @V_NEW_CDNATUBCPCSTNFE , @V_NEW_IDENTSAICSTNFE,
                                 @V_NEW_CDPRODUTO       , @V_NEW_IDENTRSAIDOP ,
                                 @V_NEW_CDTIPOOPER      , @V_NEW_CDEMPRESA,  @V_NEW_CDGRUPOFISC;


   WHILE(@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' BEGIN
         IF @V_OLD_NRINCIDCST IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrCST= '          + @V_OLD_NRINCIDCST;
         END;
         IF @V_OLD_CDIMPOSTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdImposto= '      + @V_OLD_CDIMPOSTO;
         END;
         IF @V_OLD_CDSITUTRIBNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdSituTribNfe= '  + @V_OLD_CDSITUTRIBNFE;
         END;
         IF @V_OLD_IDMODBCNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdModBcNFe= '     + @V_OLD_IDMODBCNFE;
         END;
         IF @V_OLD_IDMODBCSTNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdModBcCSTNfe= '  + @V_OLD_IDMODBCSTNFE;
         END;
         IF @V_OLD_CDTPCRPICOSTNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdTpcrPicostNfe= '+ @V_OLD_CDTPCRPICOSTNFE;
         END;
         IF @V_OLD_CDNATUBCPCSTNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdNatubcpCSTNFe= '+ @V_OLD_CDNATUBCPCSTNFE;
         END;
         IF @V_OLD_IDENTSAICSTNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntSaiCSTNfe= ' + @V_OLD_IDENTSAICSTNFE;
         END;
         IF @V_OLD_CDPRODUTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdProduto= '      + @V_OLD_CDPRODUTO;
         END;
         IF @V_OLD_IDENTRSAIDOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntrSaidOp= '   + @V_OLD_IDENTRSAIDOP;
         END;
         IF @V_OLD_CDTIPOOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper= '       + @V_OLD_CDTIPOOPER;
         END;
         IF @V_OLD_CDEMPRESA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdEmpresa= '      + @V_OLD_CDEMPRESA;
         END;
         IF @V_OLD_CDGRUPOFISC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' GrupoFisc= '      + @V_OLD_CDGRUPOFISC;
         END;

         SET @V_ITPESQ    = @V_OLD_NRINCIDCST+@V_OLD_CDIMPOSTO;
         SET @V_IDTIPOOPER = '3';
      END ELSE BEGIN
         IF @V_IDCOMANDO = 'U' BEGIN
            SET @V_ITPESQ    = @V_NEW_NRINCIDCST+@V_NEW_CDIMPOSTO;
            SET @V_IDTIPOOPER = '2';
         END ELSE BEGIN
            SET @V_ITPESQ    = @V_NEW_NRINCIDCST+@V_NEW_CDIMPOSTO;
            SET @V_IDTIPOOPER = '1';
         END;

         IF ISNULL(@V_OLD_NRINCIDCST, '#') <> ISNULL(@V_NEW_NRINCIDCST, '#') BEGIN
            SET @V_DESC = @V_DESC + ' NrCST= '          + @V_NEW_NRINCIDCST;
         END;
         IF ISNULL(@V_OLD_CDIMPOSTO, '#') <> ISNULL(@V_NEW_CDIMPOSTO, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' CdImposto= '      + @V_NEW_CDIMPOSTO;
         END;
         IF ISNULL(@V_OLD_CDSITUTRIBNFE, '#') <> ISNULL(@V_NEW_CDSITUTRIBNFE, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' CdSituTribNfe= '  + @V_NEW_CDSITUTRIBNFE;
         END;
         IF ISNULL(@V_OLD_IDMODBCNFE, '#') <> ISNULL(@V_NEW_IDMODBCNFE, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' IdModBcNFe= '     + @V_NEW_IDMODBCNFE;
         END;
         IF ISNULL(@V_OLD_IDMODBCSTNFE, '#') <> ISNULL(@V_NEW_IDMODBCSTNFE, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' IdModBcCSTNfe= '  + @V_NEW_IDMODBCSTNFE;
         END;
         IF ISNULL(@V_OLD_CDTPCRPICOSTNFE, '#') <> ISNULL(@V_NEW_CDTPCRPICOSTNFE, '#')   BEGIN
            SET @V_DESC = @V_DESC + ' CdTpcrPicostNfe= '+ @V_NEW_CDTPCRPICOSTNFE;
         END;
         IF ISNULL(@V_OLD_CDNATUBCPCSTNFE, '#') <> ISNULL(@V_NEW_CDNATUBCPCSTNFE, '#') BEGIN
            SET @V_DESC = @V_DESC + ' CdNatubcpCSTNFe= '+ @V_NEW_CDNATUBCPCSTNFE;
         END;
         IF ISNULL(@V_OLD_IDENTSAICSTNFE, '#') <> ISNULL(@V_NEW_IDENTSAICSTNFE, '#') BEGIN
            SET @V_DESC = @V_DESC + ' IdEntSaiCSTNfe= ' + @V_NEW_IDENTSAICSTNFE;
         END;
         IF ISNULL(@V_OLD_CDPRODUTO, '#') <> ISNULL(@V_NEW_CDPRODUTO, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' CdProduto= '      + @V_NEW_CDPRODUTO;
         END;
         IF ISNULL(@V_OLD_IDENTRSAIDOP, '#') <> ISNULL(@V_NEW_IDENTRSAIDOP, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' IdEntrSaidOp= '   + @V_NEW_IDENTRSAIDOP;
         END;
         IF ISNULL(@V_OLD_CDTIPOOPER, '#') <> ISNULL(@V_NEW_CDTIPOOPER, '#') BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper= '       + @V_NEW_CDTIPOOPER;
         END;
         IF ISNULL(@V_OLD_CDEMPRESA, '#') <> ISNULL(@V_NEW_CDEMPRESA, '#')   BEGIN
            SET @V_DESC = @V_DESC + ' CdEmpresa= '      + @V_NEW_CDEMPRESA;
         END;
         IF ISNULL(@V_OLD_CDGRUPOFISC, '#') <> ISNULL(@V_NEW_CDGRUPOFISC, '#')  BEGIN
            SET @V_DESC = @V_DESC + ' GrupoFisc= '      + @V_NEW_CDGRUPOFISC;
         END;

      END;
      IF NOT @V_DESC IS NULL BEGIN
         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
         INSERT INTO LOGOPERA
            (NMTABELA, DTOPERACAO,NMRESPOPER,IDTIPOOPER,DSOPERACAO,CDPESQITEM,
             DSRDMUSUOPER,DSENDUSUOPER,DSNMUSUOPER,DSMETUSUOPER,CDORESPOPER)
         VALUES
            ('CODSITUTRIBNFE', GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER,
             @V_DESC, @V_ITPESQ, @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST,
             @V_DSSERVMETHOD, @V_DSREMOTEOPER);
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                 @V_OLD_NRINCIDCST      , @V_OLD_CDIMPOSTO,
                                 @V_OLD_CDSITUTRIBNFE   , @V_OLD_IDMODBCNFE,
                                 @V_OLD_IDMODBCSTNFE    , @V_OLD_CDTPCRPICOSTNFE,
                                 @V_OLD_CDNATUBCPCSTNFE , @V_OLD_IDENTSAICSTNFE,
                                 @V_OLD_CDPRODUTO       , @V_OLD_IDENTRSAIDOP ,
                                 @V_OLD_CDTIPOOPER      , @V_OLD_CDEMPRESA,  @V_OLD_CDGRUPOFISC,

                                 @V_NEW_NRINCIDCST      , @V_NEW_CDIMPOSTO,
                                 @V_NEW_CDSITUTRIBNFE   , @V_NEW_IDMODBCNFE,
                                 @V_NEW_IDMODBCSTNFE    , @V_NEW_CDTPCRPICOSTNFE,
                                 @V_NEW_CDNATUBCPCSTNFE , @V_NEW_IDENTSAICSTNFE,
                                 @V_NEW_CDPRODUTO       , @V_NEW_IDENTRSAIDOP ,
                                 @V_NEW_CDTIPOOPER      , @V_NEW_CDEMPRESA,  @V_NEW_CDGRUPOFISC;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'LOG_DFS_CODSITUTRIBNFE','5.30.xxx';
GO
